// Show combinations of K elements amongst N
// Alain Brobecker - 2010/02/12
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define maxK 50
#define maxN 50
int K,N;
int Position[maxK];
char State[maxN];
int NbCombinations=0;

void Process() {
  int c;
  for(c=0;c<N;c++) { State[c]='.'; }
  for(c=0;c<K;c++) { State[Position[c]]='*'; }
  for(c=0;c<N;c++) { printf("%c",State[c]); }
  printf("\n");
}

//Recursive setup of all combinations
//Call it with "Combinations(0,0,N-K);"
void Combinations(int Variable,int start,int end) {
  int c;
  for(c=start;c<=end;c++) {
    Position[Variable]=c;
    if(Variable==K-1) {
      Process(); //Put here the routine to process one combination
      NbCombinations++;
    } else {
      Combinations(Variable+1,c+1,end+1);
    }
  }
}

/**** ReadNumber ****/
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  
  //read parameters from command line
  if(argc!=3) { printf("Usage: combinations N P\n"); exit(1); }
  N=ReadNumber(argv[1]);
  K=ReadNumber(argv[2]);
  Combinations(0,0,N-K);
  printf("nCk(%d;%d)=%d\n",N,K,NbCombinations);
  exit(0);
}

//THE following is from selfreference.c
//    /**** Next set of numbers ****/
//    Incremented=FALSE;
//    c=0;
//    while(Incremented==FALSE) {
//      Nb[c]=Nb[c]+1;
//      if(Nb[c]<=HighestPossibleNb)  {
//        Incremented=TRUE;
//      } else {
//        // go to next figure
//        Nb[c]=0;
//        c++;
//        if(c==MaxFigure+1) { Incremented=TRUE; Terminate=TRUE; }
//        if(c>HighestSetFigure) {
//          HighestSetFigure++;
//          HighestPossibleNb=HighestSetFigure+4;
//        }
//      }
//    }
